/* -*- Mode: Java; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *
 * Copyright (c) 2001-2002  Ted Mielczarek
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

var textLinkMenuItems = new Array("textlink-sep", "textlink-open-tab", "textlink-open-link");

var TextLink = {
  init: function() {
    var menu = document.getElementById("contentAreaContextMenu");
    menu.addEventListener("popupshowing",TextLink.showHide,false);
  },

  showHide: function() {
    var isTextSelection = false;

    if(gContextMenu)
      isTextSelection = gContextMenu.isTextSelected;

    for(var i=0; i<textLinkMenuItems.length; i++) {
      var menuitem = document.getElementById(textLinkMenuItems[i]);
      if(menuitem) {
        menuitem.hidden = !isTextSelection;
        //if(isTextSelection) {
        //  menuitem.removeAttribute("collapsed");         
        //else {
        //  menuitem.setAttribute("collapsed",true);
        //}
      }
    }
  },

  openLinkTab: function(e) {
    this.openLink(this.fixURL(this.unmangleURL(gContextMenu.searchSelected())),1);
  },

  openLinkHere: function(e) {
    this.openLink(this.fixURL(this.unmangleURL(gContextMenu.searchSelected())),0);
  },
 
  openLink: function(lnk,typ) {
    var browser = getBrowser();

    if (typ == 1) {
	browser.addTab(lnk);
    } else {
	window.loadURI(lnk);
    }
  },

  // strip bad leading and trailing characters
  unmangleURL: function(url) {
    // strip all whitespace
    url = url.replace(/[\n\t ]+/, "");
    // strip bad leading characters
    url = url.replace(/^[^a-zA-Z]+/, "");
    // strip bad ending characters
    url = url.replace(/[\.,\'\"\)\?!>\]]+$/, "");

    return url;
  },

  fixURL: function (url) {
    // make sure it has some sort of protocol
    if(url.search(/^\w+:\/\//) == -1)
      url = "http://" + url;

    // these get used a lot.  guess this makes it more useful.
    // h*p -> http
    // f*p -> ftp
    if(url.search(/^h.+p:\/\//) != -1)
      url = url.replace(/^h.+p:\/\//, "http://");
    if(url.search(/^f.+p:\/\//) != -1)
      url = url.replace(/^f.+p:\/\//, "ftp://");

    return url;
  }
}

// do the init on load
window.addEventListener("load",TextLink.init, false); 

